image: node

stages:
   - SonarScan
   - test
   - package
   - scan
   - deploy 

before_script:
   - whoami
   - pwd

variables:
  stage: SonarScan
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  only:
    - merge_requests
    - master
    - develop

teste site:
  stage: test
  before_script:
   - npm install -g broken-link-checker
  script:
   - sudo npm install && run start &
   
package site:
  stage: package
  cache:
    key: site-package
    policy: push
    paths:
      - ./builds/clayton.souza/nojejenkins
  artifacts:
    when: always
    expire_in: 2 hrs
    paths: 
    - package.json
    - app.js
    - views
    - node_modules
  script:
    - ls -lrth
    - pwd
    - npm --version  
    - npm install
    
scan site:
  stage: scan
  when: always
  before_script:
   - npm install -g snyk
  script:
    - ls -lrth
    - pwd
    - npm --version  
    - npm install

deploy site:
  stage: deploy
  script:
    - npm install --global surge
    - surge --project ./builds/clayton.souza/nojejenkins --http://localhost:8080
  after_script:
    - whoami
  variables:
    CNAME: claytonsouza.surge.sh
  environment:
    name: production
    url: http://localhost:8080
  only:
    - master
